#pragma once


#include "C_P1ImageCommonTypes.h"
#include "C_P1ImageCommonMetaData.h"
#include "P1ImageRawImage.hpp"

namespace P1
{
	namespace ImageSdk
	{

		class EXPORT_API JpegWriter
		{
		public:

			/**
			 * @brief Writes a JPEG file to the disk synchronously
			 *
			 * @param filename The path to the output file, it may be a single character string.
			 * @param bitmap The rendered bitmap
			 * @param image The raw image's in memory representation
			 * @param config Describes the JPEG metadata/preview
			 * @throw SDKException The function will throw an exception in case of failure.
			 */
			JpegWriter(std::string filename, P1::ImageSdk::BitmapImage& bitmap, P1::ImageSdk::RawImage& image, JpegConfig& config)  noexcept(false);

			/**
			 * @brief Writes a JPEG file to the disk synchronously
			 *
			 * @param filename The path to the output file, it may be a single character string.
			 * @param bitmap The rendered bitmap
			 * @param image The raw image's in memory representation
			 * @param metadata The metadatabase to writen into the image file.
			 * @param config Describes the JPEG metadata/preview
			 * @throw SDKException The function will throw an exception in case of failure.
			 */
			JpegWriter(std::string filename, P1::ImageSdk::BitmapImage& bitmap, P1::ImageSdk::RawImage& image, P1::ImageSdkC::P1MetaDataBase& metadata, JpegConfig& config)  noexcept(false);
		};
	}
}